#include "GerenciadorMuro.h"
#include <allegro.h>
#include "Muro.h"
#include "Personagem.h"
#include <iostream>


GerenciadorMuro::GerenciadorMuro( int fase ) {

    *filaMuros = new Muro[5];
    this->fase = fase;
    int velocidadeFase1 = 1;
    int velocidadeFase2 = 2;
    int delayFase1 = 0;
    int delayFase2 = 0;
	

    if(fase == 1) {
        //incializando o array com os bitmaps de fileiras de muro da primeira fase.

	    this->atualIndice = 5;
        arrayBitmapsFase1[0] = load_bitmap("./fileiras/fileiraMuros1_1.bmp", NULL);
        arrayBitmapsFase1[1] = load_bitmap("./fileiras/fileiraMuros1_2.bmp", NULL);
        arrayBitmapsFase1[2] = load_bitmap("./fileiras/fileiraMuros1_3.bmp", NULL);
        arrayBitmapsFase1[3] = load_bitmap("./fileiras/fileiraMuros1_4.bmp", NULL);
        arrayBitmapsFase1[4] = load_bitmap("./fileiras/fileiraMuros1_5.bmp", NULL);
        arrayBitmapsFase1[5] = load_bitmap("./fileiras/fileiraMuros1_6.bmp", NULL);
        arrayBitmapsFase1[6] = load_bitmap("./fileiras/fileiraMuros1_7.bmp", NULL);
        arrayBitmapsFase1[7] = load_bitmap("./fileiras/fileiraMuros1_8.bmp", NULL);
        arrayBitmapsFase1[8] = load_bitmap("./fileiras/fileiraMuros1_9.bmp", NULL);
        arrayBitmapsFase1[9] = load_bitmap("./fileiras/fileiraMuros1_10.bmp", NULL);
        arrayBitmapsFase1[10] = load_bitmap("./fileiras/fileiraMuros1_11.bmp", NULL);
        arrayBitmapsFase1[11] = load_bitmap("./fileiras/fileiraMuros1_12.bmp", NULL);
        arrayBitmapsFase1[12] = load_bitmap("./fileiras/fileiraMuros1_13.bmp", NULL);
        arrayBitmapsFase1[13] = load_bitmap("./fileiras/fileiraMuros1_14.bmp", NULL);
        arrayBitmapsFase1[14] = load_bitmap("./fileiras/fileiraMuros1_15.bmp", NULL);
        arrayBitmapsFase1[15] = load_bitmap("./fileiras/fileiraMuros1_16.bmp", NULL);
        arrayBitmapsFase1[16] = load_bitmap("./fileiras/fileiraMuros1_17.bmp", NULL);
        arrayBitmapsFase1[17] = load_bitmap("./fileiras/fileiraMuros1_18.bmp", NULL);
        arrayBitmapsFase1[18] = load_bitmap("./fileiras/fileiraMuros1_19.bmp", NULL);
        arrayBitmapsFase1[19] = load_bitmap("./fileiras/fileiraMuros1_20.bmp", NULL);

        filaMuros[0] = new Muro( *arrayBitmapsFase1[0] , 141, 0, velocidadeFase1, delayFase1);
        filaMuros[1] = new Muro( *arrayBitmapsFase1[1], 141, -95, velocidadeFase1, delayFase1);
        filaMuros[2] = new Muro( *arrayBitmapsFase1[2], 141, -190, velocidadeFase1, delayFase1);
        filaMuros[3] = new Muro( *arrayBitmapsFase1[3], 141, -285, velocidadeFase1, delayFase1);
        filaMuros[4] = new Muro( *arrayBitmapsFase1[4], 141, -380, velocidadeFase1, delayFase1);

    } else if(fase == 2) {

        //incializando o array com os bitmaps de fileiras de muro da segunda fase.
		this->atualIndice = 4;
        arrayBitmapsFase2[0] = load_bitmap("./fileiras/fileiraMuros2_1.bmp", NULL);
        arrayBitmapsFase2[1] = load_bitmap("./fileiras/fileiraMuros2_2.bmp", NULL);
        arrayBitmapsFase2[2] = load_bitmap("./fileiras/fileiraMuros2_3.bmp", NULL);
        arrayBitmapsFase2[3] = load_bitmap("./fileiras/fileiraMuros2_4.bmp", NULL);
        arrayBitmapsFase2[4] = load_bitmap("./fileiras/fileiraMuros2_5.bmp", NULL);
        arrayBitmapsFase2[5] = load_bitmap("./fileiras/fileiraMuros2_6.bmp", NULL);
        arrayBitmapsFase2[6] = load_bitmap("./fileiras/fileiraMuros2_7.bmp", NULL);
        arrayBitmapsFase2[7] = load_bitmap("./fileiras/fileiraMuros2_8.bmp", NULL);
        arrayBitmapsFase2[8] = load_bitmap("./fileiras/fileiraMuros2_9.bmp", NULL);
        arrayBitmapsFase2[9] = load_bitmap("./fileiras/fileiraMuros2_10.bmp", NULL);
        arrayBitmapsFase2[10] = load_bitmap("./fileiras/fileiraMuros2_11.bmp", NULL);
        arrayBitmapsFase2[11] = load_bitmap("./fileiras/fileiraMuros2_12.bmp", NULL);
        arrayBitmapsFase2[12] = load_bitmap("./fileiras/fileiraMuros2_13.bmp", NULL);
        arrayBitmapsFase2[13] = load_bitmap("./fileiras/fileiraMuros2_14.bmp", NULL);
        arrayBitmapsFase2[14] = load_bitmap("./fileiras/fileiraMuros2_15.bmp", NULL);

        filaMuros[0] = new Muro( *arrayBitmapsFase2[0], 141, 0, velocidadeFase2, delayFase2);
        filaMuros[1] = new Muro( *arrayBitmapsFase2[1], 141, -115, velocidadeFase2, delayFase2);
        filaMuros[2] = new Muro( *arrayBitmapsFase2[2], 141, -230, velocidadeFase2, delayFase2);
        filaMuros[3] = new Muro( *arrayBitmapsFase2[3], 141, -345, velocidadeFase2, delayFase2);
    }

}

GerenciadorMuro::~GerenciadorMuro(){
	if(fase == 1){
		for(int i = 0; i < 20; i++){
			destroy_bitmap(arrayBitmapsFase1[i]);
		}
	}else{
		for(int i = 0; i < 15; i++){
			destroy_bitmap(arrayBitmapsFase2[i]);		
		}
	}
	if(filaMuros){
		delete filaMuros[0];
		delete filaMuros[1];
		delete filaMuros[2];
		delete filaMuros[3];
		delete filaMuros[4];
		filaMuros[0] = 0;
		filaMuros[1] = 0;
		filaMuros[2] = 0;
		filaMuros[3] = 0;
		filaMuros[4] = 0;
	}
}

void GerenciadorMuro::start( BITMAP &buffer ) {
		
    if(this->fase == 1) {
    	for(int i = 0; i < 5; i++) {
    		
	    	if( this->filaMuros[i]->getY() >= 480) {
	
	            this->filaMuros[i]->setY(1);
	            this->filaMuros[i]->setBitmap(*(this->arrayBitmapsFase1[atualIndice]));
		        atualIndice = (atualIndice + 1)%20;
	
	        } else {
	        	
		        this->filaMuros[i]->descer(this->fase);

		    }
		    
		    this->filaMuros[i]->desenhar( *(&buffer) );
	    }
    } else if (this->fase == 2) {
    	for(int i = 0; i < 4; i++) {
    		
	    	if( this->filaMuros[i]->getY() >= 480) {
	
	            this->filaMuros[i]->setY(1);
	            this->filaMuros[i]->setBitmap(*(this->arrayBitmapsFase2[atualIndice]));
		        atualIndice = (atualIndice + 1)%15;
	
	        } else {
	        	
		        this->filaMuros[i]->descer(this->fase);

		    }
		    
		    this->filaMuros[i]->desenhar( *(&buffer) );
	    }
    }
}