	/*
	 * GerenciadorSetas.cpp
	 *
	 *  Created on: 01/05/2010
	 *      Author: Gabrielle Campos
	 */
	#include "GerenciadorSetas.h"
	#include "Seta.h"
	#include <iostream>
	#include <sstream>
	#include <stdio.h>

	GerenciadorSetas::GerenciadorSetas(int fase, int player){

	    //Inicializao de int's
		this->fase = fase;
		this->player = player;
		this->indiceAtual = 0;
	    this->inicializarSequenciaSetas();
	    this->setaMaisPerto = 0;
		this->exclamacao = load_bitmap("./setas/exclamacao.bmp", NULL);
		this->contadorExclamacao = 0;
		this->exclamacaoPress = false;

	    this->acertou = false;

	    arrayBitmaps[0] = load_bitmap("setas/setau1m.bmp", NULL);
	    arrayBitmaps[1] = load_bitmap("setas/setad1m.bmp", NULL);
	    arrayBitmaps[2] = load_bitmap("setas/setal1m.bmp", NULL);
	    arrayBitmaps[3] = load_bitmap("setas/setar1m.bmp", NULL);
	    arrayBitmaps[4] = load_bitmap("setas/setau2m.bmp", NULL);
	    arrayBitmaps[5] = load_bitmap("setas/setad2m.bmp", NULL);
	    arrayBitmaps[6] = load_bitmap("setas/setal2m.bmp", NULL);
	    arrayBitmaps[7] = load_bitmap("setas/setar2m.bmp", NULL);

		//Inicializao das reas de coliso.
		if(this->player == 1) {

	        areaLeft = new Seta (*arrayBitmaps[4], 9, 9, 0, 'l');
	        areaDown = new Seta (*arrayBitmaps[5], 40, 9, 0, 'd');
	        areaUp = new Seta(*arrayBitmaps[6], 71, 9, 0, 'u');
	        areaRight = new Seta (*arrayBitmaps[7], 102, 9, 0, 'r');

		} else if(this->player == 2) {

		    areaLeft = new Seta (*arrayBitmaps[4], 508, 9, 0, 'l');
	        areaDown = new Seta (*arrayBitmaps[5], 539, 9, 0, 'd');
	        areaUp = new Seta(*arrayBitmaps[6], 570, 9, 0, 'u');
	        areaRight = new Seta (*arrayBitmaps[7], 601, 9, 0, 'r');

		}

	//espao de 107 entre as setas
		if(fase == 1 && player == 1){
			arraySetas[0] = new Seta(*arrayBitmaps[0], 71, 480, 2, 'u'); //cima
			arraySetas[1] = new Seta(*arrayBitmaps[1], 40, 587, 2, 'd'); //baixo
			arraySetas[2] = new Seta(*arrayBitmaps[2], 9, 694, 2, 'l'); //esquerda
			arraySetas[3] = new Seta(*arrayBitmaps[3], 102, 801, 2, 'r'); //direita
	//espao de 87 entre as setas
		}else if(fase == 2 && player == 1){
			arraySetas[0] = new Seta(*arrayBitmaps[4], 71, 480, 2, 'u');
			arraySetas[1] = new Seta(*arrayBitmaps[5], 40, 567, 2, 'd');
			arraySetas[2] = new Seta(*arrayBitmaps[6], 9, 654, 2, 'l');
			arraySetas[3] = new Seta(*arrayBitmaps[7], 102, 741, 2, 'r');
			arraySetas[4] = new Seta(*arrayBitmaps[4], 71, 828, 2, 'u');

		}else if(fase == 1 && player == 2){
			arraySetas[0] = new Seta(*arrayBitmaps[0], 570, 480, 2, 'u');
			arraySetas[1] = new Seta(*arrayBitmaps[1], 539, 587, 2, 'd');
			arraySetas[2] = new Seta(*arrayBitmaps[2], 508, 694, 2, 'l');
			arraySetas[3] = new Seta(*arrayBitmaps[3], 601, 801, 2, 'r');

		}else if(fase == 2 && player == 2){
			arraySetas[0] = new Seta(*arrayBitmaps[4], 570, 480, 2, 'u');
			arraySetas[1] = new Seta(*arrayBitmaps[5], 539, 567, 2, 'd');
			arraySetas[2] = new Seta(*arrayBitmaps[6], 508, 654, 2, 'l');
			arraySetas[3] = new Seta(*arrayBitmaps[7], 601, 741, 2, 'r');
			arraySetas[4] = new Seta(*arrayBitmaps[4], 570, 828, 2, 'u');

		}
	}

	void GerenciadorSetas::setContadoresTempo(){

		if(this->player == 2) {
		    if(key[KEY_UP]) {
		        this->contadorTecla[0] = this->contadorTecla[0] + 1;
		    } else {
		        this->contadorTecla[0] = 0;
		    }if(key[KEY_DOWN]) {
		        this->contadorTecla[1] = this->contadorTecla[1] + 1;
		    } else {
		        this->contadorTecla[1] = 0;
		    }if(key[KEY_LEFT]) {
		        this->contadorTecla[2] = this->contadorTecla[2] + 1;
		    } else {
		        this->contadorTecla[2] = 0;
		    }if(key[KEY_RIGHT]) {
		        this->contadorTecla[3] = this->contadorTecla[3] + 1;
		    } else {
		        this->contadorTecla[3] = 0;
		    }
		}else if(this->player == 1) {
		    if(key[KEY_W]) {
		        this->contadorTecla[0] = this->contadorTecla[0] + 1;
		    } else {
		        this->contadorTecla[0] = 0;
		    }if(key[KEY_S]) {
		        this->contadorTecla[1] = this->contadorTecla[1] + 1;
		    } else {
		        this->contadorTecla[1] = 0;
		    }if(key[KEY_A]) {
		        this->contadorTecla[2] = this->contadorTecla[2] + 1;
		    } else {
		        this->contadorTecla[2] = 0;
		    }if(key[KEY_D]) {
		        this->contadorTecla[3] = this->contadorTecla[3] + 1;
		    } else {
		        this->contadorTecla[3] = 0;
		    }
		}

	}

    /**Mudei só esse método aqui. Lá no switch onde tem isso ---> é onde eu mudei.
       Agora a pessoa só acerta se ela NÃO segurar a tecla e apertar APENAS a tecla certa, ou seja
       se ela apertar todas as teclas de uma vez na hora que a setinha chegar na área de colisão ela não acerta! =D
    */
	bool GerenciadorSetas::colisaoSeta(BITMAP &buffer){

	    //seta que est mais perto da rea de coliso
	    Seta *setaMovimento = this->arraySetas[setaMaisPerto];
	    Seta *setaParada;

	    //verificar a direo da seta
	    if(setaMovimento->getDirecao() == 'u') {
	        setaParada = this->areaUp;
	    }else if(setaMovimento->getDirecao() == 'd') {
	        setaParada = this->areaDown;
	    }else if(setaMovimento->getDirecao() == 'l') {
	        setaParada = this->areaLeft;
	    }else if(setaMovimento->getDirecao() == 'r') {
	        setaParada = this->areaRight;
	    }

		int posicaoY = setaMovimento->getY();

		int limiteSuperior = setaParada->getY();
		int limiteInferior = setaParada->getY() + setaParada->getAltura();

		char coluna = setaMovimento->getDirecao();

	    if(this->player == 2){

	        switch (coluna) {
	        case 'u':
	            //verifica se a seta em movimento est na rea de coliso, se o cara no apelou e
	            //se a tecla correspondente foi apertada

	            if ((posicaoY <= limiteInferior) && (posicaoY >= limiteSuperior))
	            {
	                //---> esse if ai embaixo
	                if((key[KEY_5_PAD]) && (!key[KEY_1_PAD]) && (!key[KEY_2_PAD]) && (!key[KEY_3_PAD]) && contadorTecla[0] < 3){
	                    this->exclamacaoPress = true;
	                    this->acertou = true;
	                }else if(!acertou && setaMovimento->getY() < 9){
	                    this->acertou = false;
	                }

	                //draw_sprite(&buffer, exclamacao, setaParada->getX(), setaParada->getY());
	            }


	            break;
	        case 'd':
	            if ((posicaoY <= limiteInferior) && (posicaoY >= limiteSuperior))
	            {
	                //---> esse if ai embaixo
	                if((!key[KEY_5_PAD]) && (!key[KEY_1_PAD]) && (key[KEY_2_PAD]) && (!key[KEY_3_PAD]) && contadorTecla[1] < 3){
	                    this->exclamacaoPress = true;
	                    this->acertou = true;
	                }else if(!acertou && setaMovimento->getY() < 9){
	                    this->acertou = false;
	                }
	                //draw_sprite(&buffer, exclamacao, setaParada->getX(), setaParada->getY());
	            }

	            break;
	        case 'l':
	            if ((posicaoY <= limiteInferior) && (posicaoY >= limiteSuperior))
	            {
	                //---> esse if ai embaixo
	                if((!key[KEY_5_PAD]) && (key[KEY_1_PAD]) && (!key[KEY_2_PAD]) && (!key[KEY_3_PAD]) && contadorTecla[2] < 3){
	                    this->exclamacaoPress = true;
	                    this->acertou = true;
	                }else if(!acertou && setaMovimento->getY() < 9){
	                    this->acertou = false;
	                }
	                //draw_sprite(&buffer, exclamacao, setaParada->getX(), setaParada->getY());
	            }

	            break;
	        case 'r':
	            if ((posicaoY <= limiteInferior) && (posicaoY >= limiteSuperior))
	            {
	                //---> esse if ai embaixo
	                if((!key[KEY_5_PAD]) && (!key[KEY_1_PAD]) && (!key[KEY_2_PAD]) && (key[KEY_3_PAD]) && contadorTecla[3] < 3){
	                    this->exclamacaoPress = true;
	                    this->acertou = true;
	                }else if(!acertou && setaMovimento->getY() < 9){
	                    this->acertou = false;
	                }
	                //draw_sprite(&buffer, exclamacao, setaParada->getX(), setaParada->getY());
	            }
	            break;

	        }


	    }else if(this->player == 1){
	        switch (coluna) {
	        case 'u':
	            if ((posicaoY <= limiteInferior) && (posicaoY >= limiteSuperior))
	            {
	                //---> esse if ai embaixo
	                if((key[KEY_W]) && (!key[KEY_S]) && (!key[KEY_A]) && (!key[KEY_D]) && contadorTecla[0] < 3){
	                    this->exclamacaoPress = true;
	                    this->acertou = true;
	                }else if(!acertou && setaMovimento->getY() < 9){
	                    this->acertou = false;
	                }
	                //draw_sprite(&buffer, exclamacao, setaParada->getX(), setaParada->getY());
	            }

	            break;
	        case 'd':
	            if ((posicaoY <= limiteInferior) && (posicaoY >= limiteSuperior))
	            {
	                //---> esse if ai embaixo
	                if((!key[KEY_W]) && (key[KEY_S]) && (!key[KEY_A]) && (!key[KEY_D])&& contadorTecla[1] < 3){
	                    this->exclamacaoPress = true;
	                    this->acertou = true;
	                }else if(!acertou && setaMovimento->getY() < 9){
	                    this->acertou = false;
	                }
	                //draw_sprite(&buffer, exclamacao, setaParada->getX(), setaParada->getY());
	            }

	            break;
	        case 'l':
	            if ((posicaoY <= limiteInferior) && (posicaoY >= limiteSuperior))
	            {
	                //---> esse if ai embaixo
	                if((!key[KEY_W]) && (!key[KEY_S]) && (key[KEY_A]) && (!key[KEY_D]) && contadorTecla[2] < 3){
	                    this->exclamacaoPress = true;
	                    this->acertou = true;
	                }else if(!acertou && setaMovimento->getY() < 9){
	                    this->acertou = false;
	                }
	                //draw_sprite(&buffer, exclamacao, setaParada->getX(), setaParada->getY());
	            }

	            break;
	        case 'r':
	            if ((posicaoY <= limiteInferior) && (posicaoY >= limiteSuperior))
	            {
	                //---> esse if ai embaixo
	                if((!key[KEY_W]) && (!key[KEY_S]) && (!key[KEY_A]) && (key[KEY_D]) && contadorTecla[3] < 3){
	                    this->exclamacaoPress = true;
	                    this->acertou = true;
	                }else if(!acertou && setaMovimento->getY() < 9){
	                    this->acertou = false;
	                }
	                //draw_sprite(&buffer, exclamacao, setaParada->getX(), setaParada->getY());
	            }

	            break;

	        }


	    }

	    if(this->exclamacaoPress && contadorExclamacao < 5) {
	            draw_sprite(&buffer, exclamacao, setaParada->getX(), setaParada->getY());
	            contadorExclamacao++;
	    }else{
	        this->exclamacaoPress = false;
	        contadorExclamacao = 0;
	    }


	}

	void GerenciadorSetas::manipularSetas(BITMAP &buffer, Player &p, bool &b){

		if(this->fase == 1){
	        //1 fase e player 1
	        if(this->player == 1){

	            for(int i = 0; i<4; i++){

					if(indiceAtual < 50 || arraySetas[i]->getY() < 480)
	                	this->arraySetas[i]->subir();
	                if(arraySetas[i]->getY() <= 0) {

	                    this->arraySetas[i]->setY(480);
	                    if(indiceAtual < 50) {


	                        if(sequenciaSetas[indiceAtual] == 0) {
	                            this->arraySetas[i]->setX(71);
	                            this->arraySetas[i]->setDirecao('u');
	                        } else if (sequenciaSetas[indiceAtual] == 1) {
	                            this->arraySetas[i]->setX(40);
	                            this->arraySetas[i]->setDirecao('d');
	                        }else if (sequenciaSetas[indiceAtual] == 2) {
	                            this->arraySetas[i]->setX(9);
	                            this->arraySetas[i]->setDirecao('l');
	                        }else if (sequenciaSetas[indiceAtual] == 3) {
	                            this->arraySetas[i]->setX(102);
	                            this->arraySetas[i]->setDirecao('r');
	                        }
	                      	this->arraySetas[i]->setBitmap(*arrayBitmaps[sequenciaSetas[indiceAtual]]);
	                 	}

	                    if(acertou)
	                    	p.setaAcertada();
	                    else
	                    	p.setaErrada();
	                    this->indiceAtual += 1;
	                    if(indiceAtual == 53)
							b = true;
	                    this->setaMaisPerto = (setaMaisPerto + 1)%4;
	                    acertou = false;



	                }

	                this->arraySetas[i]->desenharNaTela(buffer);

	            }

	        }else if(this->player == 2){
	            //1㪪 fase e player 2
	            for(int i = 0; i<4; i++){

					if(indiceAtual < 50 || arraySetas[i]->getY() < 480)
	                    this->arraySetas[i]->subir();
	                if(arraySetas[i]->getY() <= 0) {
	                    this->arraySetas[i]->setY(480);
	                    if(indiceAtual < 50) {

	                        if(sequenciaSetas[indiceAtual] == 0) {
	                            this->arraySetas[i]->setX(570);
	                            this->arraySetas[i]->setDirecao('u');
	                        } else if (sequenciaSetas[indiceAtual] == 1) {
	                            this->arraySetas[i]->setX(539);
	                            this->arraySetas[i]->setDirecao('d');
	                        }else if (sequenciaSetas[indiceAtual] == 2) {
	                            this->arraySetas[i]->setX(508);
	                            this->arraySetas[i]->setDirecao('l');
	                        }else if (sequenciaSetas[indiceAtual] == 3) {
	                            this->arraySetas[i]->setX(601);
	                            this->arraySetas[i]->setDirecao('r');
	                        }

	                        this->arraySetas[i]->setBitmap(*arrayBitmaps[sequenciaSetas[indiceAtual]]);
	                    }

	                    if(acertou)
	                    	p.setaAcertada();
	                    else
	                    	p.setaErrada();
	                    this->indiceAtual += 1;
	                    if(indiceAtual == 53)
							b = true;
	                    this->setaMaisPerto = (setaMaisPerto + 1)%4;
	                    acertou = false;
	           		}
	            	this->arraySetas[i]->desenharNaTela(buffer);
	            }
	       	}
		}else if(this->fase ==2){
		    //2 fase e player 1
		    if(this->player == 1){
	            for(int i = 0; i<5; i++){
					if(indiceAtual < 50 || arraySetas[i]->getY() < 480)
	                    this->arraySetas[i]->subir();
	                if(arraySetas[i]->getY() <= 0) {
	                    this->arraySetas[i]->setY(480);
	                    if(indiceAtual < 50) {
	                        if(sequenciaSetas[indiceAtual] == 4) {
	                            this->arraySetas[i]->setX(71);
	                            this->arraySetas[i]->setDirecao('u');
	                        } else if (sequenciaSetas[indiceAtual] == 5) {
	                            this->arraySetas[i]->setX(40);
	                            this->arraySetas[i]->setDirecao('d');
	                        }else if (sequenciaSetas[indiceAtual] == 6) {
	                            this->arraySetas[i]->setX(9);
	                            this->arraySetas[i]->setDirecao('l');
	                        }else if (sequenciaSetas[indiceAtual] == 7) {
	                            this->arraySetas[i]->setX(102);
	                            this->arraySetas[i]->setDirecao('r');
	                        }
	                        this->arraySetas[i]->setBitmap(*arrayBitmaps[sequenciaSetas[indiceAtual]]);
	                    }
	                   	if(acertou)
	                    	p.setaAcertada();
	                    else
	                    	p.setaErrada();
	                    this->indiceAtual += 1;
	                    if(indiceAtual == 54)
							b = true;
	                    this->setaMaisPerto = (setaMaisPerto + 1)%5;
	                    acertou = false;

	            	}
	                this->arraySetas[i]->desenharNaTela(buffer);
	            }
		    }else if(this->player == 2){
		        //2fase e player 2
	            for(int i = 0; i<5; i++){
					if(indiceAtual < 50 || arraySetas[i]->getY() < 480)
	                	this->arraySetas[i]->subir();
	            	if(arraySetas[i]->getY() <= 0) {
	                    this->arraySetas[i]->setY(480);
	                    if(indiceAtual < 50) {
	                        if(sequenciaSetas[indiceAtual] == 4) {
	                            this->arraySetas[i]->setX(570);
	                            this->arraySetas[i]->setDirecao('u');
	                        } else if (sequenciaSetas[indiceAtual] == 5) {
	                            this->arraySetas[i]->setX(539);
	                            this->arraySetas[i]->setDirecao('d');
	                        }else if (sequenciaSetas[indiceAtual] == 6) {
	                            this->arraySetas[i]->setX(508);
	                            this->arraySetas[i]->setDirecao('l');
	                        }else if (sequenciaSetas[indiceAtual] == 7) {
	                            this->arraySetas[i]->setX(601);
	                            this->arraySetas[i]->setDirecao('r');
	                        }
	                        this->arraySetas[i]->setBitmap(*arrayBitmaps[sequenciaSetas[indiceAtual]]);
	                    }
	                    if(acertou)
	                    	p.setaAcertada();
	                    else
	                    	p.setaErrada();
	                    this->indiceAtual += 1;
	                    if(indiceAtual == 54)
							b = true;
	                    this->setaMaisPerto = (setaMaisPerto + 1)%5;
	                    acertou = false;

	                }
	                this->arraySetas[i]->desenharNaTela(buffer);
	         }
	    }
	}
}

void GerenciadorSetas::inicializarSequenciaSetas(){

    if(this->fase == 1){
        this->sequenciaSetas[0] = 3;
        this->sequenciaSetas[1] = 2;
        this->sequenciaSetas[2] = 1;
        this->sequenciaSetas[3] = 2;
        this->sequenciaSetas[4] = 3;
        this->sequenciaSetas[5] = 1;
        this->sequenciaSetas[6] = 2;
        this->sequenciaSetas[7] = 3;
        this->sequenciaSetas[8] = 0;
        this->sequenciaSetas[9] = 1;
        this->sequenciaSetas[10] = 0;
        this->sequenciaSetas[11] = 3;
        this->sequenciaSetas[12] = 3;
        this->sequenciaSetas[13] = 1;
        this->sequenciaSetas[14] = 0;
        this->sequenciaSetas[15] = 2;
        this->sequenciaSetas[16] = 1;
        this->sequenciaSetas[17] = 3;
        this->sequenciaSetas[18] = 0;
        this->sequenciaSetas[19] = 2;
        this->sequenciaSetas[20] = 1;
        this->sequenciaSetas[21] = 1;
        this->sequenciaSetas[22] = 3;
        this->sequenciaSetas[23] = 0;
        this->sequenciaSetas[24] = 0;
        this->sequenciaSetas[25] = 2;
        this->sequenciaSetas[26] = 1;
        this->sequenciaSetas[27] = 3;
        this->sequenciaSetas[28] = 1;
        this->sequenciaSetas[29] = 0;
        this->sequenciaSetas[30] = 1;
        this->sequenciaSetas[31] = 0;
        this->sequenciaSetas[32] = 3;
        this->sequenciaSetas[33] = 2;
        this->sequenciaSetas[34] = 0;
        this->sequenciaSetas[35] = 0;
        this->sequenciaSetas[36] = 3;
        this->sequenciaSetas[37] = 2;
        this->sequenciaSetas[38] = 1;
        this->sequenciaSetas[39] = 3;
        this->sequenciaSetas[40] = 0;
        this->sequenciaSetas[41] = 1;
        this->sequenciaSetas[42] = 3;
        this->sequenciaSetas[43] = 2;
        this->sequenciaSetas[44] = 0;
        this->sequenciaSetas[45] = 1;
        this->sequenciaSetas[46] = 0;
        this->sequenciaSetas[47] = 3;
        this->sequenciaSetas[48] = 2;
        this->sequenciaSetas[49] = 2;

    }else if(this->fase == 2){
        this->sequenciaSetas[0] = 4;
        this->sequenciaSetas[1] = 5;
        this->sequenciaSetas[2] = 7;
        this->sequenciaSetas[3] = 7;
        this->sequenciaSetas[4] = 6;
        this->sequenciaSetas[5] = 4;
        this->sequenciaSetas[6] = 5;
        this->sequenciaSetas[7] = 4;
        this->sequenciaSetas[8] = 6;
        this->sequenciaSetas[9] = 4;
        this->sequenciaSetas[10] = 7;
        this->sequenciaSetas[11] = 6;
        this->sequenciaSetas[12] = 5;
        this->sequenciaSetas[13] = 4;
        this->sequenciaSetas[14] = 6;
        this->sequenciaSetas[15] = 6;
        this->sequenciaSetas[16] = 4;
        this->sequenciaSetas[17] = 5;
        this->sequenciaSetas[18] = 6;
        this->sequenciaSetas[19] = 7;
        this->sequenciaSetas[20] = 7;
        this->sequenciaSetas[21] = 5;
        this->sequenciaSetas[22] = 4;
        this->sequenciaSetas[23] = 6;
        this->sequenciaSetas[24] = 7;
        this->sequenciaSetas[25] = 5;
        this->sequenciaSetas[26] = 6;
        this->sequenciaSetas[27] = 6;
        this->sequenciaSetas[28] = 4;
        this->sequenciaSetas[29] = 7;
        this->sequenciaSetas[30] = 7;
        this->sequenciaSetas[31] = 5;
        this->sequenciaSetas[32] = 4;
        this->sequenciaSetas[33] = 7;
        this->sequenciaSetas[34] = 6;
        this->sequenciaSetas[35] = 4;
        this->sequenciaSetas[36] = 5;
        this->sequenciaSetas[37] = 6;
        this->sequenciaSetas[38] = 7;
        this->sequenciaSetas[39] = 5;
        this->sequenciaSetas[40] = 5;
        this->sequenciaSetas[41] = 5;
        this->sequenciaSetas[42] = 6;
        this->sequenciaSetas[43] = 4;
        this->sequenciaSetas[44] = 7;
        this->sequenciaSetas[45] = 7;
        this->sequenciaSetas[46] = 4;
        this->sequenciaSetas[47] = 6;
        this->sequenciaSetas[48] = 5;
        this->sequenciaSetas[49] = 4;
    }
}
