/*
 * GerenciadorSetas.h
 *
 *  Created on: 01/05/2010
 *      Author: Gabrielle Campos
 */

#ifndef GERENCIADORSETAS_H_
#define GERENCIADORSETAS_H_

#include "Seta.h"
#include "Player.h"

class GerenciadorSetas{

	private:
	Seta *arraySetas[5];
	BITMAP *buffer;
	BITMAP *ponto;
	Seta *areaLeft;
	Seta *areaDown;
	Seta *areaUp;
	Seta *areaRight;
	int fase;
	int player;
	int indiceAtual;
	int contadorTecla[4];
	int sequenciaSetas[50];
	int setaMaisPerto;
	bool exclamacaoPress;
	int contadorExclamacao;

	bool acertou;

	BITMAP *arrayBitmaps[8];
	BITMAP *exclamacao;

	public:
	GerenciadorSetas(int fase, int player);
	bool colisaoSeta(BITMAP &buffer);
	void setContadoresTempo();
	void manipularSetas(BITMAP &buffer, Player &p, bool &b);
    void inicializarSequenciaSetas();

};

#endif /* GERENCIADORSETAS_H_ */
