#ifndef PLAYER_H_
#define PLAYER_H_
#include "Sangue.h"
#include "Personagem.h"
#include "Pontuacao.h"
#include <allegro.h>

class Player{
    private:
        Personagem *personagem;
        Pontuacao *pontuacao;
        Sangue *sangue;
        BITMAP *buffer;
        BITMAP *vidas;
        BITMAP *mush;
        BITMAP *cobertura;
        int posVidaX;
        int posVidaY;
    public:
        Player(BITMAP&, BITMAP&, int);
        ~Player();
        bool processar();
        void setaAcertada();
        void setaErrada();
        void resetarVidas();
       	bool morto();
       	void matar();
       	void zerarHP();
       	int getPorcentagem();
        BITMAP* desenharVidas();
        int getPontos();
};

#endif // PLAYER_H_INCLUDED
